package be.iminds.ilabt.jfed.restapi.dropwizard;

import ch.qos.logback.classic.LoggerContext;
import ch.qos.logback.classic.sift.MDCBasedDiscriminator;
import ch.qos.logback.classic.sift.SiftingAppender;
import ch.qos.logback.classic.spi.ILoggingEvent;
import ch.qos.logback.core.Appender;
import ch.qos.logback.core.Context;
import ch.qos.logback.core.Layout;
import ch.qos.logback.core.sift.AppenderFactory;
import com.fasterxml.jackson.annotation.JsonTypeName;
import io.dropwizard.logging.AbstractAppenderFactory;

import java.util.HashMap;
import java.util.Map;

/**
 * JFedRestApiDebugDataAppenderFactory provides access to all slf4j logging messages
 *
 * This needs to be registered in the file "META-INFI/services/io.dropwizard.logging.AppenderFactory"
 */
@JsonTypeName("jFedRestApiDebugData")
public class JFedRestApiDebugDataAppenderFactory extends AbstractAppenderFactory {
    private JFedLoggingAppender singleAppender = null;

    @Override
    public Appender<ILoggingEvent> build(LoggerContext loggerContext, String appName, Layout<ILoggingEvent> layout) {
        JFedLoggingAppender appender;
        if (singleAppender == null) {
            appender = new JFedLoggingAppender();
            singleAppender = appender;
        } else {
            appender = singleAppender;
        }

        appender.setName("jfed-all");
        appender.setContext(loggerContext);

        appender.start();

        return wrapAsync(appender);
    }

    public JFedLoggingAppender getAppender() {
        return singleAppender;
    }
}
